
;   ,    HID_Lib  http://pure-basic.narod.ru/libs.html#HID_Lib
;  -  PureBasic 4.31


#USB_PID       = $2010  ;  USB .
#USB_VID       = $0207
#USB_Version   = 2
#USB_Index     = 0

#ListIcon_WidhtColumn = 24 ;    
#ProgName = "uniUSB v 1.0" ;     

Enumeration    ; ,  , 
 #MainWindow
 #StatusBar

 #Image_State
 #ListIcon = #Image_State+8
 #StringSpeed
EndEnumeration

Enumeration    ; 
 #PopupMenu
 #Menu_Add_Column
 #Menu_Del_Column
  
 #Main_ToolBar
 
 #ToolBar_Start
 #ToolBar_Pause
 #ToolBar_Stop
 #ToolBar_Del
EndEnumeration

Enumeration    ; 
 #Image_x

 #Image_Icon_Start = #Image_x + 16
 #Image_Icon_Pause
 #Image_Icon_Stop
 #Image_Icon_Del
EndEnumeration

Enumeration    ;  
 #Start
 #Pause
 #Stop
EndEnumeration

LoadFont(1, "Arial", 10,#PB_Font_Bold)
If OSVersion() < #PB_OS_Windows_Vista
  LoadFont(2, "Tahoma", 14)
Else
  LoadFont(2, "Lucida Console", 15)
EndIf

SetCurrentDirectory(GetPathPart(ProgramFilename()))

CodeFile.s="UniUSB_.txt"     ;   
Old_CodeFile.s="UniCOM_.txt" ;   UniCOM.exe

RebarRECT.RECT
ProgrammState = #Stop

ListViewSpalte.LV_COLUMN 
ListViewSpalte\mask = #LVCF_FMT 
ListViewSpalte\fmt = #LVCFMT_CENTER

Procedure UpdateImage(Byte.b)  ;  ,    
 For i=0 To 7
  If Byte & 1
    SetGadgetState(#Image_State+i, ImageID(#Image_x+i*2))
  Else
    SetGadgetState(#Image_State+i, ImageID(#Image_x+i*2+1))
  EndIf
  Byte >> 1
 Next i
EndProcedure

Procedure Thread(*x)           ;             USB 
Shared ProgrammState, HID_Write_Handle
Shared TablePointer, TableCountColumn
Shared TimeDelay_Thread
Protected OutByte.b, Dim OutBuffer.b(2)

 Repeat
 
   If ProgrammState = #Start

       If TablePointer > TableCountColumn
         TablePointer=0
         SetGadgetItemText(#ListIcon,-1,"",TableCountColumn)
       Else
         SetGadgetItemText(#ListIcon,-1,"",TablePointer-1)
       EndIf
       
       For i=0 To 7
          If GetGadgetItemText(#ListIcon, i, TablePointer) = "1"
            OutByte | %10000000
          Else
            OutByte & %01111111
          EndIf
          If i<7
            OutByte >> 1
          EndIf
       Next i
       
       If HID_Write_Handle
         OutBuffer(0) = 0
         OutBuffer(1) = OutByte
         If HID_Lib_WriteDevice(HID_Write_Handle, @OutBuffer(), 2) <> 2  ;    USB 
           ProgrammState = #Stop                                         ;    
           TablePointer=0
           SetToolBarButtonState(#Main_ToolBar, #ToolBar_Pause, 0)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Start, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Pause, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Stop, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Del, 0)
           StatusBarText(#StatusBar,1,"   USB !")
           Goto Thread_m1
         EndIf
       EndIf
       
       UpdateImage(OutByte)  ;   ,    
       SetGadgetItemText(#ListIcon,-1,"",TablePointer)
       StatusBarText(#StatusBar,0," "+Str(TablePointer+1), #PB_StatusBar_Center)
       TablePointer + 1
       
       TimeDelay = TimeDelay_Thread
       If TimeDelay>100
         Delay(100)
         Repeat
         
           TimeDelay - 100
           If TimeDelay>100
             Delay(100)
           Else
             Delay(TimeDelay)
             Break
           EndIf
           
           If Old_TimeDelay <> TimeDelay_Thread Or HID_Write_Handle = 0 Or ProgrammState <> #Start
             Old_TimeDelay = TimeDelay_Thread
             Break
           EndIf
           
         ForEver
       Else  
         Delay(TimeDelay)
       EndIf

   ElseIf ProgrammState = #Pause Or ProgrammState = #Stop
   Thread_m1:
       Delay(100)
   EndIf
   
 ForEver

EndProcedure

Procedure CountListIconColumns(Gadget_ID) ; count columns 
  Protected hHdr, lResult 
  hHdr    = SendMessage_(Gadget_ID,#LVM_GETHEADER,0,0) 
  lResult = SendMessage_(hHdr,#HDM_GETITEMCOUNT,#Null,#Null) 
  ProcedureReturn lResult 
EndProcedure 


Procedure FindDevice_Timer() ;  ( 800 .)   USB HID 
Shared HID_Write_Handle, ProgrammState, TablePointer
Static Old_Test
Test=HID_Lib_DeviceTest(#USB_PID, #USB_VID, #USB_Version, #USB_Index) ;    USB HID ?
 If Test<>Old_Test
  Old_Test=Test
  If Test 
     HID_Lib_CloseDevice(HID_Write_Handle) : HID_Write_Handle=0
     HID_Write_Handle=HID_Lib_OpenDevice(#USB_PID, #USB_VID, #USB_Version, #USB_Index) ;   USB HID 
     StatusBarText(#StatusBar,0," 1", #PB_StatusBar_Center)
     StatusBarText(#StatusBar,1,"   USB ")
           SetToolBarButtonState(#Main_ToolBar, #ToolBar_Pause, 0)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Start, 0)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Pause, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Stop, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Del, 0)
           ProgrammState = #Stop
           TablePointer=0
  Else
     ProgrammState = #Stop
     HID_Lib_CloseDevice(HID_Write_Handle) : HID_Write_Handle=0
     Delay(400)
     StatusBarText(#StatusBar,0," 1", #PB_StatusBar_Center)
     StatusBarText(#StatusBar,1,"   USB !")
     TableCountColumn = CountListIconColumns(GadgetID(#ListIcon)) - 1
     UpdateImage(0)
     TablePointer=0
     For i=0 To TableCountColumn
         SetGadgetItemText(#ListIcon,-1,"",i)
     Next i
           SetToolBarButtonState(#Main_ToolBar, #ToolBar_Pause, 0)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Start, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Pause, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Stop, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Del, 0)
           
  EndIf
 EndIf
EndProcedure

Procedure Create_Image()   ;  ,    
  x=0
  For i=#Image_x To #Image_x+15
   If x=0
     color=$80DA5A
     x=1
   Else
     color=$4A7D33
     x=0
   EndIf
   If CreateImage(i, 14,22)
     If StartDrawing(ImageOutput(i))
       Box(0,0,14,22,color)
       DrawingFont(FontID(1))
       DrawingMode(#PB_2DDrawing_Transparent)
       DrawText(4,4,Str((i+2)/2),0)
       StopDrawing()
     EndIf
   EndIf
  Next i
EndProcedure

Procedure TestChannelData(*Point, Len)
 If *Point And Len>0
   Len-1
   For i=0 To Len
     Byte.b = PeekB(*Point+i)
     If Byte<>'0' And Byte<>'1'
       ProcedureReturn 0 
     EndIf
   Next i
   ProcedureReturn 1 
 EndIf
ProcedureReturn 0 
EndProcedure

Procedure LoadFile()
 Shared CodeFile, Old_CodeFile, CountColumn
 Shared ListIconGadgetID, ListViewSpalte
 Protected Dim DataFile.s(8), Speed = 100
 Protected Dim ZeroTable.b(2), Dim LenghtString(8)
 
 If FileSize(CodeFile)<0
   If FileSize(Old_CodeFile)<0
     For i=0 To 7
       AddGadgetItem(#ListIcon, i, "0")
     Next i
     ProcedureReturn Speed
   Else
     CodeFile = Old_CodeFile
   EndIf
 EndIf
 
 If ReadFile(2, CodeFile)
   CountNum=0
   While Eof(2) = 0 
     String.s = ReadString(2)
   
     Pos=FindString(LCase(String), " ",1)
     If Pos>0
       Num=Val(Trim(Left(String,Pos-1)))
       If Num>0 And Num<=8
         ChannelData.s=Trim(Mid(String,Pos+7))
         If TestChannelData(@ChannelData, Len(ChannelData)) = 1
           CountNum+1
           DataFile(Num) = ChannelData
           LenghtString(Num) = Len(ChannelData)
         Else
           MessageRequester(#ProgName, "  "+Chr(34)+CodeFile+Chr(34)+"   "+Chr(10)+"   "+Str(Num)+Chr(10)+Chr(10)+"  .", #MB_OK|#MB_ICONERROR)
           End
         EndIf
       EndIf
       Continue
     EndIf
     
     Pos=FindString(LCase(String), "",1)
     If Pos>0
       Temp=Val(Trim(Right(String,Len(String)-Pos-7)))
       If Temp>=10 And Temp<100000
         Speed=Temp
       EndIf
     EndIf
   Wend
   
   CloseFile(2)
   
   If CountNum>=8
   
     CountColumn=LenghtString(1)
     For i=2 To 8
       If CountColumn < LenghtString(i)
         CountColumn = LenghtString(i)
       EndIf
     Next i
     
     ReDim ZeroTable(CountColumn+2)
     
     For i=1 To CountColumn
       OK = 1
       For x=1 To 8
         If LenghtString(x)>=CountColumn
           If PeekB(@DataFile(x)+i-1)='1'
             OK = 0
             Break
           EndIf
         EndIf
       Next x
       If OK = 1
         ZeroTable(i) = 1 ;    
       EndIf
     Next i
     
     CountColumn-1
     For i=1 To CountColumn
       AddGadgetColumn(#ListIcon, i, "", #ListIcon_WidhtColumn)
       SendMessage_(ListIconGadgetID, #LVM_SETCOLUMN, i, @ListViewSpalte)
     Next i
   
     For i=1 To 8
       String.s = DataFile(i)
       Len = Len(String) - 1
       For x=0 To Len
       
         Char.s=Mid(String,x+1,1)
         If Char<>"1" And ZeroTable(x+1)<>1
           Char=""
         EndIf
         
         If x=0
           AddGadgetItem(#ListIcon, i-1, Char )
         Else
           SetGadgetItemText(#ListIcon, i-1, Char, x)
         EndIf
       Next x
     Next i
     
     
   Else
     MessageRequester(#ProgName, "  "+Chr(34)+CodeFile+Chr(34)+"  "+Chr(10)+"    !"+Chr(10)+Chr(10)+"  .", #MB_OK|#MB_ICONERROR)
     End
   EndIf
   
 EndIf
 
 ProcedureReturn Speed
EndProcedure

Procedure SaveFile()
 Shared CodeFile, ListIconGadgetID
 Protected CountColumn, x, y, MemSize, *mem
 Protected Char.b
 
 CountColumn=CountListIconColumns(ListIconGadgetID)-1
 MemSize=CountColumn+4
 
 If MemSize<=0
   ProcedureReturn 0 ;  
 EndIf
 
 *mem=AllocateMemory(MemSize)
 If *mem=0
   ProcedureReturn 0 ;  
 EndIf
   
 If CreateFile(2, CodeFile)
 
     For x=0 To 7
       ZeroMemory_(*mem, MemSize)
       For y=0 To CountColumn
         If GetGadgetItemText(#ListIcon, x, y) = "1"
           Char='1'
         Else
           Char='0'
         EndIf
         PokeB(*mem+y, Char)
       Next y
       WriteStringN(2, Str(x+1)+"  "+PeekS(*mem) )
     Next x
     
   WriteString(2," "+GetGadgetText(#StringSpeed) )
   CloseFile(2)
 EndIf
 
 FreeMemory(*mem)
 
EndProcedure

Procedure Callback(Window, Message, wParam, lParam)
Shared ListIconGadgetID, ActiveNum_Row
Shared ActiveNum_Column, ProgrammState

  
    If Message = #WM_NOTIFY        ; these events are send as notification messages 
      *pnmh.NMHDR = lParam  ; lParam points to a structure with more info 
      If *pnmh\hwndFrom = ListIconGadgetID ; see if it is the right gadget  
          
          If *pnmh\code = #NM_CLICK Or *pnmh\code = #NM_DBLCLK  ; user clicked in the ListView 
            *lpnmitem.NMITEMACTIVATE = lParam            
            Row.l = *lpnmitem\iItem 
            Column.l = *lpnmitem\iSubItem 
            If Row>=0 And Column>=0
              Char.s=GetGadgetItemText(#ListIcon, Row, Column)
              If Char<>"1"
               Char="1"
              Else
               Char="0"
              EndIf
              SetGadgetItemText(#ListIcon, Row, Char, Column)
            EndIf
            
         ElseIf *pnmh\code = #NM_RCLICK
           If ProgrammState = #Stop
             *lpnmitem.NMITEMACTIVATE = lParam
             If *lpnmitem\iItem >= 0 And *lpnmitem\iSubItem>=0
               ActiveNum_Row=*lpnmitem\iItem
               ActiveNum_Column=*lpnmitem\iSubItem
               DisplayPopupMenu(#PopupMenu, WindowID(#MainWindow))
             EndIf
           Else
             MessageBeep_(#MB_ICONASTERISK)
           EndIf
           SetGadgetState(#ListIcon, -1)
           SetActiveGadget(#Image_State)
         EndIf
 
      EndIf 
      
    EndIf
  
ProcedureReturn #PB_ProcessPureBasicEvents
EndProcedure

Procedure LViewProc(hwnd, uMsg, wParam, lParam)
 Shared *OldLViewProc  
    If uMsg = #WM_LBUTTONDOWN
       SetGadgetState(#ListIcon, -1)
       SetActiveGadget(#Image_State)   
   EndIf
 Result=CallWindowProc_(*OldLViewProc, hwnd, uMsg, wParam, lParam)
 
   If uMsg = #WM_LBUTTONDOWN
       SetGadgetState(#ListIcon, -1)
       SetActiveGadget(#Image_State)
   EndIf
 
 ProcedureReturn Result 
EndProcedure 

Procedure ListIcon_HeaderHight(Gadget_ID)
  Protected hHdr, lResult, R.RECT 
  hHdr    = SendMessage_(Gadget_ID,#LVM_GETHEADER,0,0) 
  GetWindowRect_(hHdr, @R)
  ProcedureReturn R\bottom - R\top
EndProcedure 


Procedure.l CreateRebar(hwndOwner, hwndTB) 

  rbi.REBARINFO 
  rbBand.REBARBANDINFO 
  icex.INITCOMMONCONTROLSEX 
    
  icex\dwSize = SizeOf(INITCOMMONCONTROLSEX) 
  icex\dwICC  = #ICC_COOL_CLASSES | #ICC_BAR_CLASSES 

  InitCommonControlsEx_(@icex) 

  hwndRB = CreateWindowEx_(#WS_EX_TOOLWINDOW, "ReBarWindow32", #Null, #WS_CHILD | #WS_VISIBLE | #WS_CLIPSIBLINGS | #WS_CLIPCHILDREN | #RBS_VARHEIGHT | #CCS_NODIVIDER, 0, 0, 0, 0, hwndOwner, #Null,  GetModuleHandle_(0), #Null) 
  rbi\cbSize = SizeOf(REBARINFO) 
  rbi\fMask  = 0 
  rbi\himl   = #Null 
  SendMessage_(hwndRB, #RB_SETBARINFO, 0, @rbi) 
  rbBand\cbSize = SizeOf(REBARBANDINFO) 
  rbBand\fMask  =  #RBBIM_TEXT | #RBBIM_STYLE | #RBBIM_CHILD  | #RBBIM_CHILDSIZE | #RBBIM_SIZE
  rbBand\fStyle = #RBBS_CHILDEDGE | #RBBS_NOGRIPPER
   
  rbBand\clrBack = GetSysColor_(#COLOR_3DFACE) 
  rbBand\clrFore = GetSysColor_(#COLOR_3DFACE) 
  
  
  
  RebarT1.s=" ."
  rbBand\lpText = @RebarT1                  ; text to display for StringGadget 
  rbBand\hwndChild = GadgetID(#StringSpeed)                 ; handle to our STringGadget 
  rbBand\cxMinChild = 40                   ; min width of band (0 hides gadget) 
  rbBand\cyMinChild = 20    ; min height of band 
  rbBand\cx = 130                           ; width of band 
          
;/ Add the band with the StringGadget 
  SendMessage_(hwndRB, #RB_INSERTBAND, -1, @rbBand) 
  
  
;         
; ;/ Get the height of the ToolBar we created earlier 
   dwBtnSize = SendMessage_(hwndTB, #TB_GETBUTTONSIZE, 0,0)
;           
;/ Set values for band with the ToolBar 
  tbtext$ = "";"ToolBar" 
  rbBand\lpText = @tbtext$                  ; text to display for ToolBar 
  rbBand\hwndChild = hwndTB                 ; handle to our ToolBar 
  rbBand\cxMinChild = 100                   ; min width of band (0 hides ToolBar) 
  rbBand\cyMinChild = (dwBtnSize>>16 )+2    ; min height of band set to button height 
  rbBand\cx = 200                           ; width of band 
 SendMessage_(hwndRB, #RB_INSERTBAND, -1, @rbBand)  
 
 ProcedureReturn hwndRB; 
EndProcedure 


If CreatePopupMenu(#PopupMenu)
   MenuItem(#Menu_Add_Column," ")
   MenuItem(#Menu_Del_Column," ")
EndIf

CatchImage(#Image_Icon_Start, ?Icon_Start, ?Icon_Start1-?Icon_Start)
CatchImage(#Image_Icon_Pause, ?Icon_Pause, ?Icon_Pause1-?Icon_Pause)
CatchImage(#Image_Icon_Stop,  ?Icon_Stop,  ?Icon_Stop1 -?Icon_Stop )
CatchImage(#Image_Icon_Del ,  ?Icon_Del,   ?Icon_Del1  -?Icon_Del  )


OpenWindow(#MainWindow,0,0,700,310,#ProgName,#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget|#PB_Window_SizeGadget|#PB_Window_Invisible|#PB_Window_ScreenCentered)
  SmartWindowRefresh(#MainWindow,1)
  WindowBounds(#MainWindow,270,310,10000,310)

  ListIconGadgetID = ListIconGadget(#ListIcon,28,36,658,250,"",#ListIcon_WidhtColumn,#PB_ListIcon_GridLines|#PB_ListIcon_FullRowSelect)
    SendMessage_(ListIconGadgetID, #LVM_SETCOLUMN, 0, @ListViewSpalte)
    SetGadgetFont(#ListIcon, FontID(2))
    ListIcon_HeaderHight = ListIcon_HeaderHight(ListIconGadgetID)
    TimeDelay_Thread=LoadFile()
    
    Create_Image()
    y=ListIcon_HeaderHight+38
    For i=0 To 7
      ImageGadget(#Image_State+i,8,y,20,20, 0)
      y+24
    Next i
    UpdateImage(0)
    
    StringGadget(#StringSpeed,88,2,50,20,Str(TimeDelay_Thread),#PB_String_Numeric)
         SendMessage_(GadgetID(#StringSpeed), #EM_LIMITTEXT, 6, #Null)
         GadgetToolTip(#StringSpeed,"  , .")
         
    CreateToolBar(#Main_ToolBar,WindowID(#MainWindow))
    ToolBar_ID=ToolBarID(#Main_ToolBar)
     
     SetWindowLongPtr_(ToolBar_ID, #GWL_EXSTYLE, 128)       ; best I can do for now 
     SetWindowLongPtr_(ToolBar_ID, #GWL_STYLE, 1442879821)  ; best I can do for now 
    
    Rebar_ID=CreateRebar(WindowID(#MainWindow), ToolBar_ID)
       ToolBarSeparator()
       ToolBarImageButton(#ToolBar_Start, ImageID(#Image_Icon_Start)) : DisableToolBarButton(#Main_ToolBar, #ToolBar_Start, 1)
         ToolBarToolTip(#Main_ToolBar, #ToolBar_Start, "")
       ToolBarImageButton(#ToolBar_Pause, ImageID(#Image_Icon_Pause)) : DisableToolBarButton(#Main_ToolBar, #ToolBar_Pause, 1)
         ToolBarToolTip(#Main_ToolBar, #ToolBar_Pause, "")
       ToolBarImageButton(#ToolBar_Stop,  ImageID(#Image_Icon_Stop))  : DisableToolBarButton(#Main_ToolBar, #ToolBar_Stop, 1)
         ToolBarToolTip(#Main_ToolBar, #ToolBar_Stop, "")
       ToolBarSeparator()
       ToolBarImageButton(#ToolBar_Del,  ImageID(#Image_Icon_Del))
         ToolBarToolTip(#Main_ToolBar, #ToolBar_Del, " ")
       

    
    CreateStatusBar(#StatusBar, WindowID(#MainWindow))
      AddStatusBarField(90)
      AddStatusBarField(#PB_Ignore)
    StatusBarText(#StatusBar,0," 1", #PB_StatusBar_Center)
    StatusBarText(#StatusBar,1,"   USB !")
    
    
    SetWindowCallback(@Callback(), #MainWindow)
    *OldLViewProc = SetWindowLongPtr_(ListIconGadgetID, #GWL_WNDPROC, @LViewProc() )

    FindDevice_Timer()
    SetTimer_(WindowID(#MainWindow), 2, 800, @FindDevice_Timer() ) ;  
    
    ThreadID=CreateThread(@Thread(), 0)  ;   
    If ThreadID=0
      MessageRequester(#ProgName, "    !"+Chr(10)+"  .", #MB_OK|#MB_ICONERROR)
      End
    EndIf
    
    
HideWindow(0,0) ;    

Repeat   ;    Repeat : Until
   Event=WaitWindowEvent() ;    
   
   If Event=#PB_Event_SizeWindow  ;   
       GetWindowRect_(Rebar_ID, @RebarRECT)
       MoveWindow_(Rebar_ID, 0, 0, WindowWidth(#MainWindow), RebarRECT\bottom - RebarRECT\top, #True)
       ResizeGadget(#ListIcon, #PB_Ignore, #PB_Ignore, WindowWidth(#MainWindow)-30, WindowHeight(#MainWindow)-(58-ListIcon_HeaderHight)-(RebarRECT\bottom - RebarRECT\top))
   
   ElseIf Event=#PB_Event_Gadget ;   
     Select EventGadget()
       Case #ListIcon            ;    
         Type=EventType()
         If Type=#PB_EventType_LeftClick Or Type=#PB_EventType_LeftDoubleClick
           SetGadgetState(#ListIcon, -1)
         EndIf

       Case #StringSpeed         ;   ,     
         GadgetToolTip(#StringSpeed,"  , .")
         If EventType()=#PB_EventType_Change
           TimeDelay_Thread=Val(GetGadgetText(#StringSpeed))
         EndIf
     EndSelect
   
   ElseIf Event=#PB_Event_Menu  ;   
      Select EventMenu()
         Case #Menu_Add_Column ; " "
           If ActiveNum_Row> -1 And ActiveNum_Column> -1
             AddGadgetColumn(#ListIcon, ActiveNum_Column+1,"", #ListIcon_WidhtColumn)
             SendMessage_(ListIconGadgetID, #LVM_SETCOLUMN, ActiveNum_Column+1, @ListViewSpalte)
             ActiveNum_Row= -1 : ActiveNum_Column= -1
           EndIf
           
         Case #Menu_Del_Column ; " "
           If ActiveNum_Row> -1 And ActiveNum_Column> -1
             CountColumns=CountListIconColumns(GadgetID(#ListIcon))
             If CountColumns>1
                 If MessageRequester(#ProgName, "       "+Str(ActiveNum_Column+1), #MB_YESNO|#MB_ICONQUESTION|#MB_DEFBUTTON2) = #IDYES
                    RemoveGadgetColumn(#ListIcon, ActiveNum_Column)
                 EndIf
             Else
               MessageRequester(#ProgName, "     ."+Chr(10)+"Ÿ  !", #MB_OK|#MB_ICONWARNING)
             EndIf
             ActiveNum_Row= -1 : ActiveNum_Column= -1
           EndIf
           
         Case #ToolBar_Start
           SetToolBarButtonState(#Main_ToolBar, #ToolBar_Pause, 0)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Start, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Pause, 0)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Stop, 0)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Del, 1)
           StatusBarText(#StatusBar,1,"   USB ")
           TablePointer = 0
           TableCountColumn = CountListIconColumns(GadgetID(#ListIcon)) - 1
           ProgrammState = #Start
                     
         Case #ToolBar_Pause
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Start, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Pause, 0)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Stop, 0)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Del, 1)
           
           If GetToolBarButtonState(#Main_ToolBar, #ToolBar_Pause)=0
             SetToolBarButtonState(#Main_ToolBar, #ToolBar_Pause, 1)
             StatusBarText(#StatusBar,1," ")
             ProgrammState = #Pause
           Else
             SetToolBarButtonState(#Main_ToolBar, #ToolBar_Pause, 0)
             StatusBarText(#StatusBar,1,"   USB ")
             ProgrammState = #Start
           EndIf
           
         Case #ToolBar_Stop
           SetToolBarButtonState(#Main_ToolBar, #ToolBar_Pause, 0)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Start, 0)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Pause, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Stop, 1)
           DisableToolBarButton(#Main_ToolBar, #ToolBar_Del, 0)
           StatusBarText(#StatusBar,0," 1", #PB_StatusBar_Center)
           StatusBarText(#StatusBar,1,"   USB ")
           ProgrammState = #Stop
           Delay(150)
           TableCountColumn = CountListIconColumns(GadgetID(#ListIcon)) - 1
           UpdateImage(0)
           For i=0 To TableCountColumn
             SetGadgetItemText(#ListIcon,-1,"",i)
           Next i
           
           If HID_Write_Handle
             OutBuffer.w=0
             HID_Lib_WriteDevice(HID_Write_Handle, @OutBuffer, 2)
           EndIf
           
         Case #ToolBar_Del
           If MessageRequester(#ProgName, "    ?"+Chr(10)+"(   ).", #MB_YESNO|#MB_ICONQUESTION|#MB_DEFBUTTON2) = #IDYES
             ClearGadgetItems(#ListIcon)
             CountColumns=CountListIconColumns(GadgetID(#ListIcon))
             For i=1 To CountColumns
              RemoveGadgetColumn(#ListIcon, 1)
             Next i
             
             For i=0 To 7
               AddGadgetItem(#ListIcon, i, "0")
             Next i
           EndIf
      EndSelect
   EndIf
   
Until Event=#PB_Event_CloseWindow  ;      

SaveFile() ;      
KillTimer_(WindowID(#MainWindow), 2) ;  
KillThread(ThreadID)                 ;   

If HID_Write_Handle
   OutBuffer.w=0
   HID_Lib_WriteDevice(HID_Write_Handle, @OutBuffer, 2)
   HID_Lib_CloseDevice(HID_Write_Handle)
EndIf

End                                  ;   


DataSection                         ;        
   Icon_Start:
       IncludeBinary "Files\Start.ico"
   Icon_Start1:
   
   Icon_Pause:
       IncludeBinary "Files\Pause.ico"
   Icon_Pause1:
   
   Icon_Stop:
       IncludeBinary "Files\Stop.ico"
   Icon_Stop1:
   
   Icon_Del:
       IncludeBinary "Files\Del.ico"
   Icon_Del1:
EndDataSection
; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 716
; FirstLine = 691
; Folding = ---
; EnableThread
; EnableXP
; UseIcon = Files\.ico
; Executable = UniUSB.exe
; SubSystem = UserLibThreadSafe
; CompileSourceDirectory
; IncludeVersionInfo
; VersionField0 = 1.0.0.0
; VersionField1 = 1.0.0.0
; VersionField2 = ϸ
; VersionField3 = UniUSB
; VersionField4 = 1.0
; VersionField5 = 1.0
; VersionField6 = UniUSB (32 bit)
; VersionField7 = UniUSB
; VersionField8 = UniUSB
; VersionField9 =  ϸ
; VersionField12 =   - PureBasic 4.31
; VersionField13 = pure-basic@yandex.ru
; VersionField14 = http://pure-basic.narod.ru
; VersionField17 = 0419 Russian